'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MetadataRecord = exports.DocumentRecord = exports.AppRecord = undefined;

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Github = require('github');

const AppRecord = exports.AppRecord = new _immutable2.default.Record({
  executionState: 'not connected',
  github: new Github(), // default to no auth until setup
  channels: null,
  spawn: null,
  connectionFile: null,
  notificationSystem: null,
  kernelSpecName: null,
  isSaving: false,
  modified: false,
  theme: 'light'
});

const DocumentRecord = exports.DocumentRecord = new _immutable2.default.Record({
  notebook: null,
  cellPagers: new _immutable2.default.Map(),
  cellStatuses: new _immutable2.default.Map(),
  outputStatuses: new _immutable2.default.Map(),
  stickyCells: new _immutable2.default.Map(),
  focusedCell: null,
  cellMsgAssociations: new _immutable2.default.Map(),
  msgCellAssociations: new _immutable2.default.Map(),
  copied: new _immutable2.default.Map()
});

const MetadataRecord = exports.MetadataRecord = new _immutable2.default.Record({
  past: new _immutable2.default.List(),
  future: new _immutable2.default.List(),
  filename: ''
});