'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.copyNotebook = copyNotebook;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function copyNotebook(filename) {
  return new Promise((resolve, reject) => {
    const readStream = _fs2.default.createReadStream(filename);
    readStream.on('error', reject);

    const base = _path2.default.basename(filename, '.ipynb');

    _tmp2.default.tmpName({ prefix: `${ base }-Copy`, postfix: '.ipynb' }, (err, newFilename) => {
      if (err) {
        reject(err);
      }

      const writeStream = _fs2.default.createWriteStream(newFilename);
      writeStream.on('error', reject);

      readStream.pipe(writeStream);
      writeStream.on('close', resolve(newFilename));
    });
  });
}